package com.muimi.mail.internal;

import org.eclipse.jface.preference.PreferenceManager;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.help.WorkbenchHelp;
import org.eclipse.ui.internal.IHelpContextIds;
import org.eclipse.ui.internal.WorkbenchPlugin;
import org.eclipse.ui.internal.dialogs.WorkbenchPreferenceDialog;
import org.eclipse.update.internal.ui.UpdatePerspective;
import org.eclipse.update.internal.ui.UpdateUI;
import org.eclipse.update.internal.ui.views.IEmbeddedWebBrowser;

import com.muimi.mail.MailPlugin;

/**
 * EclipseInternalpbP[W𗘗p鑋NX
 * 
 * @author Shinji Miyamoto
 */
public class InternalBridge {

	public static void openWorkbenchPreference(){
//		OpenPreferencesAction action = new OpenPreferencesAction();
//		action.run();

		PreferenceManager pm = WorkbenchPlugin.getDefault().getPreferenceManager();	
		WorkbenchPreferenceDialog d = new WorkbenchPreferenceDialog(MailPlugin.getShell(), pm);
		d.create();
		WorkbenchHelp.setHelp(d.getShell(), IHelpContextIds.PREFERENCE_DIALOG);
		d.open();
		
	}


	public static void openInBrowzer(String link){
		IWorkbenchPage page = UpdateUI.getActivePage();
		try {
			IViewPart part = page.showView(UpdatePerspective.ID_BROWSER);
			((IEmbeddedWebBrowser) part).openTo(link);
		} catch (PartInitException ex) {
			UpdateUI.logException(ex);
		}
	}


}
