package com.muimi.mail.ui;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceStore;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

/**
 * AJEg쐬EBU[hy[W
 * @author Shinji Miyamoto
 */
public class CreateAccountWizardPage extends WizardPage{

	private AccountSettingPage page;

	public CreateAccountWizardPage() {
	  super("account");
	  setTitle("Account Create");
	  setDescription("Input Account Informations");
	}


	public void createControl(Composite parent) {

		IPreferenceStore store = new PreferenceStore();
		page = new AccountSettingPage(store);
		Control c = page.createControl(parent);

		setControl(c);
	}


	public IPreferenceStore getPreference(){
		return page.getPreference();
	}



}
