/*
 * POP3Store.java
 *
 * Copyright (C) 1998-2000 FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Copyright (C) 1998-2000N FreeBeans <freebeans@mub.biglobe.ne.jp>
 *
 * {vO̓t[E\tgEFAłBȂ́AFree Software Foundation 
 * \GNU ʌLgṕuo[WQv͂ȍ~̊eo[W
 * ̒炢ꂩIÃo[W߂ɏ]Ė{vO
 * ĔЕz܂͕ύX邱Ƃł܂B
 * {vO͗LpƂ͎v܂AЕzɂẮAsꐫyѓړIK
 * ɂĂ̈Öق̕ۏ؂܂߂āAȂۏ؂sȂ܂BڍׂɂĂ
 * GNU ʌLgpǂ݂B
 *
 * Ȃ́A{vOƈꏏGNU ʌLgp̎ʂ󂯎Ă
 * ͂łBłȂꍇ́AFree Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA ֎莆ĂB
 */

package jp.gr.java_conf.roadster.net.pop;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FilenameFilter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.BitSet;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import java.util.StringTokenizer;
import javax.mail.Folder;
import javax.mail.Flags;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.URLName;
import javax.mail.event.StoreEvent;

import javax.mail.internet.MimeMessage;

/**
 * POP3Store NX.
 *
 * POP3T[õbZ[WMs.
 *
 * POP3Store ̓́Aȉ̃vpeBŐł.
 * <table BORDER="1">
 * <th>vpeB</th>
 * <th>^</th>
 * <th></th>
 * <th>ftHgl</th>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.rootDirectory</code></td>
 *  <td><code>String</code></td>
 *  <td>T[oMbZ[WۑfBNg</td>
 *  <td>JgfBNg.(System.getProperty("user.dir"))</td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.authMode</code></td>
 *  <td><code>String</code></td>
 *  <td>POP3F؃[hANORMAL ܂ APOP w肷.</td>
 *  <td>NORMAL</td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.receivingFolder</code></td>
 *  <td><code>String</code></td>
 *  <td>T[oMbZ[Wi[tH_.
 *  <td>INBOX</td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.checkInterval</code></td>
 *  <td><code>int</code></td>
 *  <td>T[õbZ[WIɃ`FbNԊu.iPʁFj<BR>
 *      ̃vpeB 0 w肵ꍇɂ͒Iȃ`FbN͍sȂ.</td>
 *  <td>10</td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.leaveOnServer</code></td>
 *  <td><code>boolean</code></td>
 *  <td>Mς݂bZ[WAT[oɎcw肷.<br>
 *      falsew肵ꍇAMbZ[W̓T[oォ폜B</td>
 *  <td><code>true</code></td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.checkActions</code></td>
 *  <td><code>String</code></td>
 *  <td>T[o烁bZ[WM^C~O.ȉ̒lw\.<BR>
 *      <TABLE BORDER>
 *      <TR>
 *       <td>&lt;init&gt;</td><td>Folder IuWFNg쐬ꂽ_.<B>Ȃ</B></td>
 *      </TR>
 *      <TR>
 *       <td>open</td><td>Folder.open() \bhĂяoꂽ_.</td>
 *      </TR>
 *      <TR>
 *       <td>hasNewMessages</td><td>Folder.hasNewMessages() Ăяoꂽ_.</td>
 *      </TR>
 *      </TABLE>
 *      w肷ꍇɂ̓J} (,) ŋ؂Ďw肷.<BR>
 *      j&lt;init&gt;,hasNewMessages
 *   </td>
 *   <td>
 *     open,hasNewMessages
 *   </td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.receiveImmediatery</code></td>
 *  <td><code>boolean</code>
 *  <td>LcheckActionsŎw肵\bhĂяoꂽ_ŁAɃbZ[WM邩w肷.<BR>
 *      true w肵ꍇA\bh^[_ŃbZ[W̎M͊Ă.<BR>
 *      false w肵ꍇAbZ[W̃_E[h̓obNOEhōs.
 *   </td>
 *   <td>
 *     <code>false</code>
 *   </td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.listHiddenFolders</code></td>
 *  <td><code>boolean</code></td>
 *  <td>BfBNgXgAbv邩w肷B<code>true</code>w肳ꂽꍇABfBNgXgAbvB
 *      ̃vpeB͎sJava2ȍ~łȂƖAJDK1.1̊ł͏ true ƂȂB</td>
 *   <td><code>false</code></td>
 * </tr>
 *
 * <tr>
 *  <td><code>jp.gr.java_conf.roadster.net.pop.timeout</code></td>
 *  <td><code>int</code></td>
 *  <td><code>Socket</code>̃^CAEgԂ~bŎw肷BOw肵ꍇɂ̓^CAEgȂB</td>
 *   <td><code>0</code></td>
 * </tr>
 *
 * </table>
 */
public class POP3Store extends Store {
	/**
	 * INBOX tH_̖.(=INBOX)
	 */
	private static final String INBOX_NAME = "INBOX";
	
	/**
	 * UIDXgt@C̖O.(=uidl.dat)
	 */
	protected static final String UIDL_FILENAME = "uidl.dat";
	
	/**
	 * vpeB̊.(jp.gr.java_conf.roadster.net.pop)
	 */
	protected static final String BASE_PROPERTY = "jp.gr.java_conf.roadster.net.pop.";
	
	/**
	 * [gfBNgw肷vpeB.
	 */
	public static final String ROOTDIRECTORY_PROPERTY = BASE_PROPERTY + "rootDirectory";
	
	/**
	 * MbZ[W폜邩w肷vpeB.
	 * "true" | "false" Ŏw肷.
	 */
	public static final String LEAVE_ON_SERVER_PROPERTY = BASE_PROPERTY + "leaveOnServer";

	/**
	 * bZ[WMtH_w肷vpeB.
	 */
	public static final String RECEIVING_FOLDER_PROPERTY = BASE_PROPERTY + "receivingFolder";
	
	/**
	 * bZ[W̎Ms\bhw肷vpeB.
	 */
	public static final String CHECK_ACTION_PROPERTY = BASE_PROPERTY + "checkActions";
	
	/**
	 * 
	 */
	protected static final String RECEIVE_IMMEDIATERY_PROPERTY = BASE_PROPERTY + "receiveImmediatery";
	
	/**
	 * vpeB CHECK_ACTION_PROPERTY Ɏw肷l.
	 * FolderIuWFNg쐬ꂽ_ŁAT[o烁bZ[WM.
	 */
	protected static final String RECEIVING_ACTION_INIT            = "<init>";
	
	/**
	 * vpeB CHECK_ACTION_PROPERTY Ɏw肷l.
	 * Folder.open() Ăяoꂽ_ŁAT[o烁bZ[WM.
	 */
	protected static final String RECEIVING_ACTION_OPEN            = "open";

	/**
	 * vpeB CHECK_ACTION_PROPERTY Ɏw肷l.
	 * Folder.hasNewMessages() Ăяoꂽ_ŁAT[o烁bZ[WM.
	 */
	protected static final String RECEIVING_ACTION_HASNEWMESSAGES  = "hasNewMessages";

	/**
	 * T[oチbZ[W̃`FbNԊuw肷vpeB.
	 * ̐Ŏw肷. 0 ̏ꍇɂ͒IɎMsȂ.
	 */
	public static final String INTERVAL_PROPERTY = BASE_PROPERTY + "checkInterval";
	
	/**
	 * ItC[hw肷vpeB.
	 * "true" | "false" Ŏw肷.
	 */
	public static final String OFFLINEMODE_PROPERTY = BASE_PROPERTY + "offline";
	
 	/**
 	 * F؃[hw肷vpeB. 
 	 * l "NORMAL" ܂ "APOP" w肷.
 	 */
 	public static final String AUTHMODE_PROPERTY = BASE_PROPERTY + "authMode";
 	
 	/**
 	 * vpeB AUTHMODE_PROPERTY Ɏw肷l.
 	 * ʏ̔F(USER/PASS R}hɂF؁jsꍇɎw肷.
 	 */
 	private static final String NORMAL_AUTH = "NORMAL";
 	
 	/**
 	 * vpeB AUTHMODE_PROPERTY Ɏw肷l.
 	 * APOPɂF؂sꍇɎw肷.
 	 */
 	private static final String APOP_AUTH   = "APOP";
	
	/**
	 * Bt@CXg\邩w肷vpeBB
	 * "true" | "false" Ŏw肷BftHg false AJava2ȍ~ŖƋ@\ȂB
	 */
	public static final String LIST_HIDDEN_FOLDERS_PROPERTY = BASE_PROPERTY + "listHiddenFolders";

	/**
	 * ڑ^CAEgԂw肷vpeBBint Ŏw肷B
	 * ftHg͂O
	 */
	public static final String TIMEOUT_PROPERTY = BASE_PROPERTY + "timeout";

	/**
	 * POP3Client.
	 * ̃NXpăT[oƒʐMAbZ[WM.
	 */
	protected POP3Client client;
	
	/**
	 * UIDXg.Mς݃[ UID i[Ă.
	 * ̃XgɃT[o擾ׂbZ[W肷.
	 */
	protected Vector uidList;
	
	/**
	 * [gfBNg.
	 * ̃fBNgzɃ[ۑ.
	 * ftHgł́ASystem.getProperty("user.dir") ƂȂ.
	 */
	protected File rootDirectory = new File(System.getProperty("user.dir"));
	
	/**
	 * MbZ[WT[oɕۑ邩.
	 * ftHgł true.
	 */
	protected boolean leaveOnServer = true;
	
	/**
	 * ɃbZ[W_E[h邩.
	 */
	protected boolean receiveImmediatery = false;
	
	/**
	 * T[õbZ[W`FbNԊui~bPʁj
	 * ftHgl͂PO.<BR>
	 * vpeBŕύX\ł.iݒPʂ͕j
	 */
	protected long checkInterval;
	protected static final long DEFAULT_CHECK_INTERVAL = 10L * 60L* 1000L;
	
	/**
	 * ItC[hœ삷邩.
	 * ftHgł false.
	 */
	protected boolean offlineMode = false;
	
	/**
	 * F؃[h. ftHg NORMAL.
	 */
	protected String authMode = NORMAL_AUTH;
	
	/**
	 * BfBNgXg\邩BftHgl falseB
	 * ̃IvV́AJava2ȍ~ŖƋ@\ȂBiJDK1.1ł́A true Ƃ݂Ȃj
	 */
	protected boolean listHiddenFolders = false;
	
	/**
	 * ^CAEgԁiPʁF~bj
	 */
	protected int timeout = 0;
	
	/**
	 * T[oMbZ[Wi[tH_.
	 * ftHgł "INBOX".
	 */
	protected String receivingFolderName = INBOX_NAME;
	
	/**
	 * bZ[W̎MJn铮.
	 */
	protected Vector checkActions = new Vector();
	
	/**
	 * UIDLt@C.
	 */
	protected File uidlFile;
	
	/**
	 * }X^tH_.
	 */
	protected Hashtable masterFolders = new Hashtable();
	
	/**
	 * bZ[WMXbh.
	 */
	protected MessageReceiver receiver;
	
	/**
	 * T[õbZ[WIɃ`FbNXbh.
	 */
	protected IntervalTimer timerThread;

	/**
	 * localstore w肷p[^L[.
	 */
	private static final String LOCALSTORE_KEY = "localstore";

	/**
	 * authmode w肷p[^L[.
	 */
	private static final String AUTHMODE_KEY   = "authmode";
	
	/**
	 * RXgN^.
	 * ̃RXgN^ protected ł͓삵Ȃ.
	 * K public ɂKv.
	 *
	 * @param	session Storê߂̃ZbVIuWFNg.
	 * @param	url	StoreŎgp URLName IuWFNg.
	 */
	public POP3Store(Session session, URLName urlname) {
		super(session, urlname);
		initStore(urlname);
	}
	
	/**
	 * POP3T[oɐڑ.
	 * ڑAT[o͂ɐؒfAKvɂȂꍇɍĐڑ.
	 *
	 * @param	host	zXg.
	 * @param	port	|[gԍ.
	 * @param	username	[U.
	 * @param	password	pX[h.
	 *
	 * @return	ɐڑoꍇ true. [UF؂Ɏsꍇ false.
	 * @exception javax.mail.MessagingException	[UF؈ȊǑŐڑɎsꍇ.
	 */
	protected boolean protocolConnect(String host, int port, String user, String password) throws MessagingException {
System.out.println("[protocolConnect]");

		try {
			if (! offlineMode) {
				// POP3Client 쐬.
				client = new POP3Client();
				if (debug) {
					client.setDebug(true);
				}
				client.setHost(host);
				if (port != -1) {
					client.setPort(port);
				}
				if (authMode.equals(NORMAL_AUTH)) {
					client.setAuthorizationMode(POP3Client.NORMAL_AUTHORIZATION);
				} else if (authMode.equals(APOP_AUTH)) {
					client.setAuthorizationMode(POP3Client.APOP_AUTHORIZATION);
				}
				client.setTimeout(timeout);
				client.setUser(user);
				client.setPassword(password);
				client.connect();
			}
			// MessageReceiver .
			if (offlineMode) {
				receiver = new OfflineMessageReceiver();
			} else if (receiveImmediatery) {
				receiver = new DefaultMessageReceiver(client);
			} else {
				receiver = new BackgroundMessageReceiver(new DefaultMessageReceiver(client));
				((BackgroundMessageReceiver) receiver).start();
			}
			return true;
		} catch (POP3AuthenticationFailedException pae) {	// F؂Ɏs.
			debugOut("POP3Store.protocolConnect():" + pae);
			return false;
		} catch (IOException ioe) {
			throw new MessagingException("IOException", ioe);
		} finally {
			
//TODO ɐؒfȂƁH
//			try {
//				if (client != null) {
//					client.disconnect();			// ɐؒf.
//				}
//			} catch (IOException ioe) {
//				debugOut("POP3Store.protocolConnect():" + ioe);
//				ioe.printStackTrace();
//			}
		}
	}

	/**
	 * ڑ.
	 * T[oƂ̐ڑؒf.
	 *
	 * @throws MessagingException	G[ꍇ.
	 */
	public synchronized void close() throws MessagingException {
		try {
			
			if (receiver != null) {
				if (receiver instanceof BackgroundMessageReceiver) {
					((BackgroundMessageReceiver) receiver).stopReceiving();
				}
				receiver = null;
			}
			timerThread = null;	// QƂNA. ̃Xbh POP3Folder.isConnected() == false ƂȂ_ŏI.
			MessageIndex.saveAll();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} finally {
			super.close();
			debugOut("POP3Store.close():closed.");
		}
	}

	/**
	 * ftHgtH_Ԃ.
	 * ݂̎ł́APOP3DefaultFolder ̃CX^XԂĂ.
	 *
	 * @return	ftHgtH_.݂ POP3DefaultFolder̃CX^X.
	 * @throws MessagingException	G[ꍇ.
	 */
	public synchronized Folder getDefaultFolder() throws MessagingException {
		return getFolder("");
	}

	/**
	 * w肳ꂽÕtH_Ԃ.
	 * POP3Store ł́ArɃtH_̑啶͋ʂȂ.
	 * AtH_쐬̖̂ƂẮA啶^͕ێ.
	 *
	 * JavaMail̎dlł́AuFolder IuWFNgStoreɂăLbVȂv
	 * ƂȂĂ邽߁ÃtH_w肳ꂽꍇɂAقȂ Folder IuWFNgԂ.
	 *
	 * @param	name	tH_̖O.啶^͋ʂȂ."INBOX" ͓ʂȃtH_ł.
	 *                  POP3Storeł́A"" i󕶎j̓ftHgtH_\.
	 * @return		w肳ꂽOɑΉtH_.
	 * @exception	javax.mail.MessagingException	G[ꍇ.
	 * @exception	java.lang.IllegalStateException	ڑԂɂȂꍇ.
	 */
	public Folder getFolder(String name) throws MessagingException {
		if (! isConnected()) {
			throw new IllegalStateException("Not connected");
		}
		if (name.startsWith("/")) {
			name = name.substring(1);
		}
		if (name.equalsIgnoreCase(INBOX_NAME)) {
			name = INBOX_NAME;
		}
		POP3Folder folder = null;
		synchronized (masterFolders) {
			POP3Folder masterfolder = null;
			
			Enumeration e = masterFolders.keys();	
			while (e.hasMoreElements()) { // rɂ́A啶^𖳎.
				String mastername = (String) e.nextElement();
				if (name.equalsIgnoreCase(mastername)) {
					masterfolder = (POP3Folder) masterFolders.get(mastername);
					name = mastername;	// łɑ݂tH_Ɠ̖OƂ.
				}
			}
			if (name.equals("")) {
				folder = new POP3DefaultFolder(this);
			} else {
				folder = new POP3Folder(this, name);
			}
			if (masterfolder == null) {
				masterfolder = folder;
				masterFolders.put(name, masterfolder);
			}	
		}
		return folder;
	}

	/**
	 * w肳ꂽÕtH_Ԃ.
	 * ŁAgetFolder(url.getFile()) ĂяoĂ.
	 *
	 * @param	url	tH_̖O.
	 * @exception	javax.mail.MessagingException.
	 * @exception	java.lang.IllegalStateException	ڑԂɂȂꍇ.
	 */
	public Folder getFolder(URLName url) throws MessagingException {
		return getFolder(url.getFile());
	}
	
	/**
	 * Ci[NXĂяo߂ɍēx protected 錾.
	 *
	 * @param	type	Cxg̃^CvB
	 * @param	message	ʒm郁bZ[WB
	 */
	protected void notifyStoreListeners(int type, String message) {
		super.notifyStoreListeners(type, message);
	}
	
	/**
	 * ̃IuWFNgsvɂȂ_ŌĂяoB
	 */
	protected void finalize() throws Throwable {
		try {
			if (isConnected()) {
				close();
			}
		} finally {
			super.finalize();
		}
	}
		
	// ȍ~ POP3Store Ǝ̃\bh
	/**
	 * fobOo.
	 * debug tB[h true ̏ꍇɂ̂ System.err ɃbZ[Wo͂.
	 *
	 * @param msg	o̓bZ[W.
	 */
	protected void debugOut(String msg) {
		if (debug) {
			StringBuffer sb = new StringBuffer("DEBUG:");
			sb.append(msg);
			System.err.println(sb.toString());
		}
	}
	
	/**
	 * Store .
	 */
	private void initStore(URLName urlname) {
		initShutdownHook();
		loadProperties();
		loadParameters(urlname);
		loadUIDL();

		// rootfBNg݂Ȃꍇɂ͍쐬.
		if (! getRootDirectory().exists()) {
			getRootDirectory().mkdirs();
		}
		
		// INBOX tH_݂Ȃꍇ͍쐬.
		File inboxFolder = new File(rootDirectory, INBOX_NAME);
		if (! inboxFolder.exists()) {
			inboxFolder.mkdirs();
		}
	}
	
	/**
	 * Vbg_EtbNǉB
	 */
	private void initShutdownHook() {
		try {
			Class[] paramClass = new Class[1];
			paramClass[0] = Thread.class;
			
			Method method = Runtime.class.getMethod("addShutdownHook", paramClass);
			Runtime runtime = Runtime.getRuntime();
			
			Object[] param = new Object[1];
			param[0] = new Thread() {
				public void run() {
					try {
						debugOut("POP3Store shutdown now");
						close();
					} catch (MessagingException me) {
						me.printStackTrace();
					}
				}
			};
			method.invoke(runtime, param);
		} catch (IllegalAccessException iae) {
			iae.printStackTrace();
			debugOut("POP3Store.initShutodownHook:IllegalAccessException:" + iae);
		} catch (NoSuchMethodException nsme) {	// JDK1.3 ȑÕo[Wɂ́AaddShutdownHook ݂͑ȂB
//			nsme.printStackTrace();
			debugOut("POP3Store.initShutdownHook:NoSuchMethodException:" + nsme);
		} catch (InvocationTargetException ite) {
			Throwable t = ite.getTargetException();
			if (t instanceof Error) {
				throw (Error) t;	// G[͂̂܂ܓB
			} else if (t instanceof Exception) {
				debugOut("POP3Store.initShutdownHook:InvocationTergetException:targetException:" + t);
			}
		}
	}
	
	/**
	 * vpeBǂݍ݁AetB[h.
	 */
	private void loadProperties() {
		// [gfBNg𓾂.
		String root = session.getProperty(ROOTDIRECTORY_PROPERTY);
		if (root == null) {
			rootDirectory = new File(System.getProperty("user.dir"));
		} else {
			rootDirectory = new File(root);
		}
		debugOut(ROOTDIRECTORY_PROPERTY + "=" + rootDirectory.getAbsolutePath());
		
		// MԊuvpeB瓾.
		String interval = session.getProperty(INTERVAL_PROPERTY);
		if (interval == null) {
			checkInterval = DEFAULT_CHECK_INTERVAL;
		} else {
			checkInterval = Long.parseLong(interval) * 1000L * 60L;	// ~bɕϊ.
		}
		debugOut(INTERVAL_PROPERTY + "=" + checkInterval + " (ms)");

		// MbZ[WT[oɎc𓾂.
		String los = session.getProperty(LEAVE_ON_SERVER_PROPERTY);
		if (los == null) {
			leaveOnServer = true;
		} else {
			leaveOnServer = Boolean.valueOf(los).booleanValue();
		}
		debugOut(LEAVE_ON_SERVER_PROPERTY + "=" + leaveOnServer);
		
		// ItC[hœ삷邩𓾂.
		String off = session.getProperty(OFFLINEMODE_PROPERTY);
		if (off == null) {
			offlineMode = false;
		} else {
			offlineMode = Boolean.valueOf(off).booleanValue();
		}
		debugOut(OFFLINEMODE_PROPERTY + '=' + offlineMode);
		
		// F؃[h.
		String auth = session.getProperty(AUTHMODE_PROPERTY);
		if (auth == null) {
			authMode = NORMAL_AUTH;
		} else {
			authMode = auth.toUpperCase();
		}
		debugOut(AUTHMODE_PROPERTY + '=' + authMode);

		// bZ[WMtH_𓾂.
		String fname = session.getProperty(RECEIVING_FOLDER_PROPERTY);
		if (fname == null) {
			receivingFolderName = INBOX_NAME;
		} else {
			receivingFolderName = fname;
		}
		debugOut(RECEIVING_FOLDER_PROPERTY + '=' + receivingFolderName);
		
		// bZ[WMANV𓾂.
		String actns = session.getProperty(CHECK_ACTION_PROPERTY);
		if (actns == null) {
			checkActions.addElement(RECEIVING_ACTION_OPEN);
			checkActions.addElement(RECEIVING_ACTION_HASNEWMESSAGES);
		} else {
			StringTokenizer tokenizer = new StringTokenizer(actns.trim(), ",");
			while (tokenizer.hasMoreTokens()) {
				checkActions.addElement(tokenizer.nextToken());
			}
		}
		Enumeration e  = checkActions.elements();
		actns = "";
		while (e.hasMoreElements()) {
			actns += (String) e.nextElement() + ",";
		}
		debugOut(CHECK_ACTION_PROPERTY + '=' + actns);
		actns = null;
	
		// bZ[W𒼂ɎM邩肷.
		String im = session.getProperty(RECEIVE_IMMEDIATERY_PROPERTY);
		if (im == null) {
			receiveImmediatery = false;
		} else {
			receiveImmediatery = Boolean.valueOf(im).booleanValue();
		}
		debugOut(RECEIVE_IMMEDIATERY_PROPERTY + '=' + receiveImmediatery);
		
		// BtH_XgAbv邩肷B
		String lhf = session.getProperty(LIST_HIDDEN_FOLDERS_PROPERTY);
		if (lhf == null) {
			listHiddenFolders = false;
		} else {
			listHiddenFolders = Boolean.valueOf(lhf).booleanValue();
		}
		// File.isHidden() \bhT|[gĂȂł
		// isHiddenIvVT|[gȂƂfobOo͂ɕ\B
		if (! SubFolderFilter.isHiddenMethodSupported()) {
			debugOut("WARNING:" + LIST_HIDDEN_FOLDERS_PROPERTY + " not supported because method File.isHidden() not exists, ignored.");
		}
		debugOut(LIST_HIDDEN_FOLDERS_PROPERTY + '=' + listHiddenFolders);

		// Socket̃^CAEgԂ肷B
		String to = session.getProperty(TIMEOUT_PROPERTY);
		if (to == null) {
			timeout = 0;
		} else {
			timeout = Integer.parseInt(to);
		}
		debugOut(TIMEOUT_PROPERTY + '=' + timeout);
	}
	
	
	/**
	 * URLNameɎw肳ꂽp[^ǂݍ.
	 *
	 * @param	urlname	URLName.
	 */
	private void loadParameters(URLName urlname) {
		Hashtable options = parseParameters(urlname);
		Enumeration e = options.keys();
		debugOut("POP3Store.loadParameters(): parameter loading...");
		String params = "";
		while (e.hasMoreElements()) {
			String key = (String) e.nextElement();
			String value = (String) options.get(key);
			if (params.length() > 0) {
				params += ',';
			}
			params += key + '=' + value;
		}
		debugOut(params);
		String rd = (String) options.get(LOCALSTORE_KEY);
		if (rd != null) {
			rootDirectory = new File(rd);
			debugOut("rootDirectory has changed to " + rootDirectory);
		}
		
		String am = (String) options.get(AUTHMODE_KEY);
		if (am != null) {
			authMode = am;
			debugOut("authMode has changed to " + authMode);
		}
		
		debugOut("POP3Store.loadParameters(): done.");
	}
	
	/**
	 * w肳ꂽURLNamẽp[^p[X.
	 *
	 * @param	urlname	͑ΏۂƂȂ URLName.
	 * @return	͌ʂi[ Hashtable.
	 */
	private Hashtable parseParameters(URLName urlname) {
		Hashtable options = new Hashtable();
		String optstr = urlname.getFile();
		if (optstr != null) {
			final int startpos = optstr.indexOf('?');
			if (startpos != -1 && startpos < optstr.length() - 1) {
				optstr = optstr.substring(startpos + 1);
				StringTokenizer st = new StringTokenizer(optstr, "&");
				while (st.hasMoreTokens()) {
					String pair = st.nextToken();
					int eqpos = pair.indexOf('=');
					String lvalue = (eqpos != -1) ? pair.substring(0, eqpos) : null;
					String rvalue = (eqpos != -1 && eqpos < pair.length() - 1) ? pair.substring(eqpos + 1) : null;
					if (lvalue != null) {
						options.put(lvalue, rvalue);
					}
				}
			}
		}
		return options;
	}

	/**
	 * UIDLt@Cǂݍ.
	 */
	private void loadUIDL() {
		uidlFile = new File(getRootDirectory(), UIDL_FILENAME);
		try {
			FileInputStream fis = new FileInputStream(uidlFile);
			BufferedInputStream bis = new BufferedInputStream(fis, 16 * 1024);
			ObjectInputStream ois = new ObjectInputStream(bis);
			uidList = (Vector) ois.readObject();
			ois.close();
		} catch (FileNotFoundException fnfe) {
			String dbgmsg = "UIDL file " + UIDL_FILENAME + " not found.";
			debugOut(dbgmsg);
			notifyStoreListeners(StoreEvent.NOTICE, dbgmsg);
			uidList = new Vector();
		} catch (IOException ioe) {
			String dbgmsg = "IOException " + ioe;
			debugOut(dbgmsg);
			notifyStoreListeners(StoreEvent.ALERT, dbgmsg);
			uidList = new Vector();
		} catch (ClassNotFoundException cnfe) {
			String dbgmsg = "ClassNotFoundException " + cnfe;
			debugOut(dbgmsg);
			notifyStoreListeners(StoreEvent.ALERT, dbgmsg);
			uidList = new Vector();
		}
	}
	
	/**
	 * [gfBNgԂ.
	 * [gfBNgƂ́AbZ[Wۑt@C쐬ۂ
	 * fBNĝƂł.
	 *
	 * @return	[gfBNg.
	 */
	protected File getRootDirectory() {
		return rootDirectory;
	}
	
	/**
	 * tH_ƃCxgbZ[WMΏۂłꍇA
	 * T[o烁bZ[WMāAw肳ꂽtH_ɒǉ.
	 * ^C}ĂȂꍇAs.
	 *
	 * @param	folder	bZ[Wǉ Folder.
	 * @param	actionName	Cxg.
	 */
	protected synchronized void receiveMessages(POP3Folder folder, String actionName) throws MessagingException {
		String dbgmsg = "POP3Store.receiveMessages(): folder=" + folder.getFullName() + " actionName=" + actionName;
		if (receivingFolderName.equalsIgnoreCase(folder.getFullName()) && checkActions.contains(actionName)) {
			dbgmsg += " receiving...";
			debugOut(dbgmsg);
			if (checkInterval > 0 && timerThread == null) {
				timerThread = new IntervalTimer(folder, receiver);
				timerThread.start();
			} else {
				receiver.receive(folder);
			}
		} else {
			dbgmsg += " skipped.";
			debugOut(dbgmsg);
		}
	}
	
	/**
	 * Folder.list()gpFilenameFilter̃CX^XԂB
	 *
	 * @see	jp.gr.java_conf.roadster.net.pop.POP3Folder.list()
	 */
	FilenameFilter getFilenameFilter(String pattern) {
		return new SubFolderFilter(pattern, listHiddenFolders);
	}
	
	/**
	 * bZ[WMNX.
	 * T[o烁bZ[WMAw肳ꂽtH_ɒǉ.
	 */
	class DefaultMessageReceiver implements MessageReceiver {
		/**
		 * POP3Client.
		 */
		private POP3Client client;
		
		/**
		 * bZ[WT[oMAtH_ɒǉ DefaultMessageReceiver IuWFNg쐬.
		 *
		 * @param	client	POP3Client.
		 */
		public DefaultMessageReceiver(POP3Client client) {
			this.client = client;
		}
		
		/*
		 * T[o烁bZ[WMAw肳ꂽtH_ɒǉ.
		 * SẴbZ[WM܂ŃubN.
		 * tH_ւ̃bZ[Wǉ́APbZ[W appendMessage()\bh
		 * ĂяoƂōsĂ.<BR>
		 *
		 * @param	targetFolder	bZ[WM邽߂̃tH_.
		 * @exception	javax.mail.MessagingException	G[ꍇ.
		 */
		public synchronized void receive(POP3Folder targetFolder) throws MessagingException {
System.out.println("[receive]" + Thread.currentThread().getName());
			try {
				if (! targetFolder.exists()) {
					debugOut(targetFolder + " not exits.");
					return;
				}
System.out.println("[isConnected]");
				if (! client.isConnected()) {
					client.connect();
				}
				client.rset();
				final int messageCount = client.getMessageCount();
				debugOut("MessageCount=" + messageCount);
				
				// T[o擾ׂbZ[W肷.
				// ŏɁAT[oŐVUIDL𓾂.
				boolean failedUIDL = false;
				Vector latestUIDL = new Vector();
				try {
					for (int i = 0; i < messageCount; ++i) {
						latestUIDL.addElement(client.getUID(i));
					}
				} catch (POP3NegativeResponseException p3nre) {
					debugOut("UIDL command failed: " + p3nre);
					failedUIDL = true;
				}
				
				// M̕Kv郁bZ[Wm肷.
				BitSet needReceive = new BitSet();
				for (int i = 0; i < latestUIDL.size(); ++i) {
					if (! uidList.contains(latestUIDL.elementAt(i))) {
						needReceive.set(i);
					}
				}
				BitSet received = new BitSet();

				// bZ[WM.
				Message msgs[] = new Message[1];
				for (int i = 0; i < messageCount; ++i) {
					if (needReceive.get(i)) {
						debugOut("Retrieve message:" + (i + 1));
						InputStream ins = client.retrieve(i);
						MimeMessage message = new MimeMessage(session, ins);
						ins.close();
						message.setFlag(Flags.Flag.SEEN, false);
						message.setFlag(Flags.Flag.RECENT, true);

						msgs[0] = message;
						targetFolder.appendMessages(msgs);
					}
					received.set(i);
				}
				
				// bZ[W폜.
				if (! leaveOnServer) {	// bZ[W폜.
					for (int i = 0; i < messageCount; ++i) {
						if (received.get(i)) {
							debugOut("Delete message: " + (i + 1));
							client.delete(i);
						}
					}
				}
				// Mς݃[UIDLXV.
				uidList.removeAllElements();
				for (int i = 0; i < latestUIDL.size(); ++i) {
					if (received.get(i)) {
						uidList.addElement(latestUIDL.elementAt(i));
					}
				}
				client.disconnect();
			} catch (POP3AuthenticationFailedException pafe) {
				debugOut("POP3 authentication is faield:" + pafe);
				throw new MessagingException("POP3AuthenticationFailedException", pafe);
			} catch (IOException ioe) {
				debugOut("IOException occured while receiving message(s):" + ioe);
				throw new MessagingException("IOException", ioe);
			} finally {
				try {
					saveUIDL(uidList);
				} catch (IOException ioe) {
					debugOut("IOException occured while receiving message(s):" + ioe);
					throw new MessagingException("IOException", ioe);
				}
			}
		}
		
		/**
		 * UIDLt@CɕۑB
		 *
		 * @param	uidList	ۑΏۂƂȂUIDL
		 * @throws	java.io.IOException	G[ꍇB
		 */
		private void saveUIDL(Vector uidList) throws IOException {
			FileOutputStream fos = new FileOutputStream(uidlFile);
			ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(fos, 16 * 1024));
			oos.writeObject(uidList);
			oos.close();
			debugOut("Saving UIDL file ... done");
		}
	}
	
	
	/**
	 * ItC[hMessageReceiver.
	 */
	class OfflineMessageReceiver implements MessageReceiver {
		/**
		 * ItC[hɂ́AɃ^[.
		 *
		 * @param	folder	tH_..
		 * @exception	javax.mail.MessagingException	G[ꍇ.
		 */
		public void receive(POP3Folder folder) throws MessagingException {
			return;
		}
	}
	
	/**
	 * obNOEhŃbZ[W̎MsNX.
	 * Dx NORM_PRIORITY - 1 œ삷.
	 */
	class BackgroundMessageReceiver extends Thread implements MessageReceiver {
		/**
		 * MbZ[Wi[ Folder ̃L[.
		 * L[̃TCY͂Pł.
		 * iVector gĂ̂́AR[hǂ݂₷邽߁j
		 */
		private Vector waitingQueue = new Vector(1);
		
		/**
		 * M쒆ł邱ƂtO.
		 */
		private volatile boolean running;
		
		/**
		 * MessageReceiver.
		 */
		private MessageReceiver receiver;
		
		/**
		 * bZ[W̎MobNOEhōs BackgroundMessageReceiver IuWFNg쐬.<BR>
		 * ̃Xbh Daemon thread Ƃē삷.
		 *
		 */
		protected BackgroundMessageReceiver(MessageReceiver receiver) {
			this.receiver = receiver;
			setDaemon(true);
		}
		
		/*
		 * T[o烁bZ[WMAw肳ꂽtH_ɒǉ.
		 * <OL>
		 *  <LI>MΏۂƂȂtH_L[ɓĂ邩𒲂ׂ.
		 *  <LI>Ȃ wait() .
		 *  <LI>L[FolderIuWFNgo.
		 *  <LI>T[o烁bZ[WMAFolderIuWFNgɒǉ.
		 *  <LI>T[oؒf.
		 * </OL>
		 * JԂ.<BR>
		 * OƁÃ[v͏I.
		 */
		public void run() {
			running = true;
			try {
				while (running) {
					POP3Folder targetFolder = null;
					synchronized (this) {
						while (running && waitingQueue.isEmpty()) {
							wait();
						}
						if (! running) {
							return;
						}
						targetFolder = (POP3Folder) waitingQueue.elementAt(0);
					}
					
//TODO sleepP
//System.out.println("wait for auth interval");
//Thread.sleep(3000);
					receiver.receive(targetFolder);
					
					
					waitingQueue.removeElementAt(0);
				}
			} catch (MessagingException me) {
				me.printStackTrace();
				//debugOut("BackgroundMessageReceiver.run():MessagingException occured. " + me);
				//notifyStoreListeners(StoreEvent.ALERT, me.toString());
			} catch (InterruptedException ie) {
				debugOut("MessageReceiver.run():InterruptedException occured. " + ie);
				notifyStoreListeners(StoreEvent.ALERT, ie.toString());
			} finally {
				running = false;
			}
		}
		
		/**
		 * tH_L[Ɏw肳ꂽ Folder IuWFNgǉ.
		 * ۂ̎ḾAʃXbhōs.<BR>
		 *
		 * M҂tH_L[ɂ̃tH_ǉAɃ^[.
		 * łɃL[ɃtH_ꍇɂ́AȂɂɃ^[.
		 *
		 * @param	folder	bZ[WM folder.
		 */
		public synchronized void receive(POP3Folder folder) throws MessagingException {
			if (waitingQueue.isEmpty()) {
				debugOut("MessageReceiver.receive():waitingQueue is empty.");
				waitingQueue.addElement(folder);
				notify();
			} else {
				debugOut("MessageReceiver.receive():waitingQueue is NOT empty, skipped.");
			}
		}

		/**
		 * bZ[W̎M𒆎~.
		 * ~܂ŃubN.
		 */
		public synchronized void stopReceiving() {
			try {
				System.out.println("[STOP]");
				running = false;
				notify();
				join();
			} catch (InterruptedException ie) {
				ie.printStackTrace();
			}
		}
	}
	
	/**
	 * IMessageReceiver.receive() Ăяof[Xbh.
	 * ̃Xbh́ADx NORM_PRIORITY + 1 œ삷.
	 * قƂǂ̎Ԃ sleep() ĉ߂Aڂo߂Ƃ
	 * MessageReceiver.receive() ĂяoāA܂ sleep() .
	 */
	private class IntervalTimer extends Thread {
		/**
		 * bZ[Wǉ Folder.
		 */
		private POP3Folder targetFolder;
		
		/**
		 * bZ[WMpIuWFNg.
		 */
		private MessageReceiver receiver;
		
		/**
		 * IɃbZ[WMAw肳ꂽtH_ append 
		 * IntervalTimer NX̃CX^X쐬.
		 *
		 * @param folder	bZ[WǉtH_.
		 * @param	receiver	bZ[WMpIuWFNg.
		 */
		public IntervalTimer(POP3Folder folder, MessageReceiver receiver) {
			targetFolder = folder;
			this.receiver = receiver;
			setPriority(Thread.NORM_PRIORITY + 1);
			setDaemon(true);
		}
		
		/**
		 * MessageReceiver.receive() ĂяoA莞 sleep() 
		 * ƂJԂ.
		 * checkInterval  0 ȉ̏ꍇɂ́AȂɂɃ^[.
		 */
		public void run() {
			if (checkInterval <= 0) {
				debugOut("IntervalTimer.run():checkInterval <= 0");
				return;
			}
			while (isConnected()) {
				try {
					receiver.receive(targetFolder);
					sleep(checkInterval);
				} catch (InterruptedException ie) {
					debugOut("IntervalTimer.run():" + ie);
					ie.printStackTrace();
				} catch (MessagingException me) {
					debugOut("IntervalTimer.run():" + me);
					me.printStackTrace();
				}
			}
		}
	}



	/* ( Javadoc)
	 * @see javax.mail.Service#connect()
	 */
	public void connect() throws MessagingException {
System.out.println("before connect");
		super.connect();
System.out.println("after connect");
	}

}
