package com.muimi.mail.sample;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.muimi.mail.ui.editor.content.ContentEditor;
import com.muimi.mail.ui.editor.content.ContentEditor_Old;
import com.muimi.mail.ui.editor.content.IContentEditor;

/**
 * [GfB^̃eXgp
 * @author Shinji Miyamoto
 */
public class ContentEditorTest {

	public static void main(String[] args) {

		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		
		shell.setLayout(new FillLayout());
		shell.setText("hoge");

		IContentEditor editor = new ContentEditor_Old(null);
		editor.createContent(shell, false);

		editor.setText(
			"aaa" + "\n"
			+ "bbb"+ "\n"
			+ ">>"+ "\n"
			+ "> " + "\n"
			+ ">" + "\n"
			+ "aaa http://muimi.com bbb"+ "\n"
			+ "aaa mui@muimi.com bbb"+ "\n"
			+ "hogehoge"+ "\n"
			+ "org.eclipse.debug.ui.DebugView" + "\n"
			+ "aaaa"
		);

		shell.setSize(400, 400);
		
		//shell.pack();
		shell.open();
		
		while(!shell.isDisposed()){
			if(!display.readAndDispatch()){
				display.sleep();
			}
		}
		display.dispose();
		
	}
}
