package com.muimi.mail.ui;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

import com.muimi.mail.MailPlugin;

/**
 * [p[XyNeBu
 * @author Shinji Miyamoto
 */
public class PerspectiveFactory implements IPerspectiveFactory {

	public PerspectiveFactory() {
	}


	public void createInitialLayout(IPageLayout layout)  {
		
		String editorArea = layout.getEditorArea();
		
		IFolderLayout topLeft = layout.createFolder("topLeft",
			IPageLayout.LEFT,
			0.25f,
			editorArea);
		topLeft.addView(MailPlugin.FOLDER_VIEW_ID);
		
		IFolderLayout bottomRight = layout.createFolder(
			"bottomRight",
			IPageLayout.BOTTOM,
			0.50f,
			editorArea
			);
		bottomRight.addView(MailPlugin.MESSAGE_VIEW_ID);

	}

}
