package com.muimi.mail.ui.editor;

import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.part.EditorActionBarContributor;

/**
 * [GfB^EditorActionBarContributor
 * @author Shinji Miyamoto
 */
public class MailEditorActionBarContributor extends EditorActionBarContributor{
	
	private SendAction sendAction = new SendAction();
	private ReplyAction replyAction = new ReplyAction();
	private AttachAction attachAction = new AttachAction();
	

	public void contributeToToolBar(IToolBarManager toolBarManager) {

		toolBarManager.add(sendAction);
		toolBarManager.add(replyAction);
		toolBarManager.add(attachAction);
	}



	public void setActiveEditor(IEditorPart targetEditor) {
		System.out.println("setActivateEditor");
		sendAction.setActiveEditor(targetEditor);
		replyAction.setActiveEditor(targetEditor);
		attachAction.setActiveEditor(targetEditor);
	}

}
