package com.muimi.mail.ui.editor;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IEditorPart;

import com.muimi.mail.PluginResources;

/**
 * MANV
 * @author Shinji Miyamoto
 */
public class SendAction extends Action{

	private IEditorPart editor;

	public SendAction(){
		setText("Send");
		setToolTipText("Send Mail");
		setImageDescriptor(PluginResources.IMAGE_SEND);
	}


	public void run(){
		((MailEditor)editor).sendMail();
	}

	public void setActiveEditor(IEditorPart editor){
		this.editor = editor;

		MessageModel messageModel = (MessageModel)editor.getEditorInput();
		if(messageModel.isNewMessage()){
			setEnabled(true);
		}else{
			setEnabled(false);
		}
	}

}
